! $Id: parameters.SMZprime.omega.f90,v 1.1 2004/05/04 14:37:17 reuter Exp $
!
! Copyright (C) 2000 by Thorsten Ohl <ohl@hep.tu-darmstadt.de>
! and others
!
! O'Mega is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! O'Mega is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
module omega_parameters_whizard
  use omega_kinds !NODEP!
  use omega_constants !NODEP!
  use omega_parameters_little !NODEP!
  use parameters
  implicit none
  private
  public :: import_from_whizard
contains
  subroutine import_from_whizard (par)
    type(parameter_set), intent(in) :: par
    real(kind=omega_prec) :: e, qelep, qeup, qedwn
    mass(1:34) = 0
    width(1:34) = 0
    mass(3) = par%ms
    mass(4) = par%mc
    mass(5) = par%mb
    mass(6) = par%mtop
    mass(8) = par%mtoph
    width(8) = par%wtoph
    width(6) = par%wtop
    mass(11) = par%me
    mass(13) = par%mmu
    mass(15) = par%mtau
    mass(23) = par%mZ
    width(23) = par%wZ
    mass(24) = par%mW
    width(24) = par%wW
    mass(25) = par%mH
    width(25) = par%wH
    mass(26) =  xi0 * mass(23)
    width(26) =  0
    mass(27) =  xipm * mass(24)
    width(27) =  0
    mass(32) = par%mZH
    width(32) = par%wZH
    mass(34) = par%mWH
    width(34) = par%wWH
    vev = 2 * par%mW * par%sw / par%ee 
    e = par%ee
    sinthw = par%sw
    sin2thw = sinthw**2
    costhw = par%cw
    qelep = - 1
    qeup = 2.0_omega_prec / 3.0_omega_prec
    qedwn = - 1.0_omega_prec / 3.0_omega_prec
    g = e / sinthw
    gcc = - g / 2 / sqrt (2.0_double)
    gncneu(1) = - g / 2 / costhw * ( + 0.5_double)
    gnclep(1) = - g / 2 / costhw * ( - 0.5_double - 2 * qelep * sin2thw)
    gncup(1)  = - g / 2 / costhw * ( + 0.5_double - 2 * qeup  * sin2thw)
    gncdwn(1) = - g / 2 / costhw * ( - 0.5_double - 2 * qedwn * sin2thw)
    gncneu(2) = - g / 2 / costhw * ( + 0.5_double)
    gnclep(2) = - g / 2 / costhw * ( - 0.5_double)
    gncup(2)  = - g / 2 / costhw * ( + 0.5_double)
    gncdwn(2) = - g / 2 / costhw * ( - 0.5_double)
    qlep = - e * qelep
    qup = - e * qeup
    qdwn = - e * qedwn
    qw = e
    iqw = (0,1)*qw
    gzww = g * costhw
    igzww = (0,1)*gzww
    gwww = g
    igwww = (0,1)*gwww
    ghww = mass(24) * g
    ghhww = g**2 / 2.0
    ghzz = mass(23) * g / costhw
    ghhzz = g**2 / 2.0 / costhw**2
    ghtt = - mass(6) / vev
    ghbb = - mass(5) / vev
    ghcc = - mass(4) / vev
    ghtautau = - mass(15) / vev
    gh3 = - 3 * par%mH**2 / vev
    gh4 = (par%mH)**2 / vev**2
!!! Additional parameters compared to the Standard Model
    gnchlep(1) = par%glepl
    gnchneu(1) = par%gneul
    gnchup(1) = par%gupl
    gnchdwn(1) = par%gdwnl
    gnchlep(2) = par%glepr
    gnchneu(2) = 0
    gnchup(2) = par%gupr
    gnchdwn(2) = par%gdwnr
    qzup = - e * qeup * sin2thw
    cospsi = sqrt(1 - sinpsi**2)
    atpsi = cospsi / sinpsi
    sccs = sinpsi * cospsi * (1.0_omega_prec - 2.0_omega_prec * sinpsi**2)
    sccs2 = (1.0_omega_prec - 2.0_omega_prec * sinpsi**2) / sinpsi / cospsi
    gcch = gcc * atpsi
    ! gnch = g * atpsi / 4.0_omega_prec
    iqzh = (0,-1) * g * v2F2 * sccs
    iqh = iqzh / costhw
    qzup = - e * qeup * sin2thw
    gzhthth = vF
    ghyhvv = - ghww
    ghyhww = - ghww * sccs2
    ghyhzz = - mass(23) * g * sccs2
    ghyhhvv = - g**2 / 2.0
!!! Suppressed couplings
    gzhthth = vF
  end subroutine import_from_whizard
end module omega_parameters_whizard
